﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace Paketbote
{
    /// <summary>
    /// class for custom Toggle-Switch
    /// </summary>
    public class custom_ToggleSwitch : CheckBox
    {
        public custom_ToggleSwitch()
        {
            SetStyle(ControlStyles.UserPaint | ControlStyles.AllPaintingInWmPaint, true);
            Padding = new Padding(6);
        }
        protected override void OnPaint(PaintEventArgs e)
        {
            SolidBrush dark = new SolidBrush(Color.FromArgb(64, 64, 64));
            SolidBrush orange = new SolidBrush(Color.FromArgb(255, 152, 0));
            this.OnPaintBackground(e);
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;
            using (var path = new GraphicsPath())
            {
                int d = Padding.All;
                int r = Height - 2 * d;
                path.AddArc(d, d, r, r, 90, 180);
                path.AddArc(Width - r - d, d, r, r, -90, 180);
                path.CloseFigure();

                e.Graphics.FillPath(Checked ? dark : dark, path);
                r = Height - 1;
                var rect = Checked ? new Rectangle(Width - r - 1, 0, r, r)
                                   : new Rectangle(0, 0, r, r);
                e.Graphics.FillEllipse(Checked ? orange : orange, rect);
            }
        }
    }
}
