﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Paketbote
{
    /// <summary>
    /// updates the keys in the preferences depending on the user-input
    /// </summary>
    public partial class frm_KeyListener : Form
    {
        custom_Button btn_key_input;
        string key_sel;
        Keys key_val;

        public frm_KeyListener(string key_sel, Keys key_val)
        {
            InitializeComponent();
            this.key_sel = key_sel;
            this.key_val = key_val;
            btn_key_input = new custom_Button(translate_key(key_val), new Point(this.Width / 2 - 25,40), new Size(50, 50));
            this.Controls.Add(btn_key_input);
        }

        //string replacement and validation of keys
        public static string translate_key(Keys key)
        {
            string str_key = key.ToString();
            switch (key)
            {
                case Keys.Space:
                    str_key = "▬";
                    break;
                case Keys.Left:
                    str_key = "◄";
                    break;
                case Keys.Up:
                    str_key = "▲";
                    break;
                case Keys.Right:
                    str_key = "►";
                    break;
                case Keys.Down:
                    str_key = "▼";
                    break;
                case Keys.A:
                    break;
                case Keys.B:
                    break;
                case Keys.C:
                    break;
                case Keys.D:
                    break;
                case Keys.E:
                    break;
                case Keys.F:
                    break;
                case Keys.G:
                    break;
                case Keys.H:
                    break;
                case Keys.I:
                    break;
                case Keys.J:
                    break;
                case Keys.K:
                    break;
                case Keys.L:
                    break;
                case Keys.M:
                    break;
                case Keys.N:
                    break;
                case Keys.O:
                    break;
                case Keys.Q:
                    break;
                case Keys.R:
                    break;
                case Keys.S:
                    break;
                case Keys.T:
                    break;
                case Keys.U:
                    break;
                case Keys.V:
                    break;
                case Keys.W:
                    break;
                case Keys.X:
                    break;
                case Keys.Y:
                    break;
                case Keys.Z:
                    break;
                case Keys.NumPad0:
                    str_key = "0";
                    break;
                case Keys.NumPad1:
                    str_key = "1";
                    break;
                case Keys.NumPad2:
                    str_key = "2";
                    break;
                case Keys.NumPad3:
                    str_key = "3";
                    break;
                case Keys.NumPad4:
                    str_key = "4";
                    break;
                case Keys.NumPad5:
                    str_key = "5";
                    break;
                case Keys.NumPad6:
                    str_key = "6";
                    break;
                case Keys.NumPad7:
                    str_key = "7";
                    break;
                case Keys.NumPad8:
                    str_key = "8";
                    break;
                case Keys.NumPad9:
                    str_key = "9";
                    break;
                default:
                    str_key="";
                    break;
            }
            return str_key;
        }

        //set the new key and save the setting once "Enter" was pressed
        private void frm_KeyListener_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode==Keys.Enter)
            {
                switch (key_sel)
                {
                    case "sp_left":                  
                        if (key_val != Keys.None)
                        {
                            Properties.Settings.Default.key_sp_left = key_val;
                        }                    
                        break;
                    case "sp_right":
                        if (key_val != Keys.None)
                        {
                            Properties.Settings.Default.key_sp_right = key_val;
                        }                      
                        break;
                    case "sp_up":
                        if (key_val != Keys.None)
                        {
                            Properties.Settings.Default.key_sp_up = key_val;
                        }                        
                        break;
                    case "sp_down":
                        if (key_val != Keys.None)
                        {
                            Properties.Settings.Default.key_sp_down = key_val;
                        }                      
                        break;
                    case "mp_left":
                        if (key_val != Keys.None)
                        {
                            Properties.Settings.Default.key_mp_left = key_val;
                        }                        
                        break;
                    case "mp_right":
                        if (key_val != Keys.None)
                        {
                            Properties.Settings.Default.key_mp_right = key_val;
                        }                        
                        break;
                    case "mp_up":
                        if (key_val != Keys.None)
                        {
                            Properties.Settings.Default.key_mp_up = key_val;
                        }                
                        break;
                    case "mp_down":
                        if (key_val == Keys.None)
                        {
                            Properties.Settings.Default.key_mp_down = key_val;
                        }                  
                        break;
                    default:
                        break;
                }
                Properties.Settings.Default.Save();
                this.Close();
            }
            else
            {
                btn_key_input.Text = translate_key(e.KeyCode);
                if (btn_key_input.Text !="")
                {
                    key_val = e.KeyCode;
                }
                else
                {
                    key_val = Keys.None;
                }
            }
        }
    }
}
