﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Paketbote
{
    public partial class frm_Start : Form
    {
        Form frm_Game;
        Form frm_Key;
        custom_Button btn_sp_left;
        custom_Button btn_sp_right;
        custom_Button btn_sp_up;
        custom_Button btn_sp_down;
        custom_Button btn_mp_left;
        custom_Button btn_mp_right;
        custom_Button btn_mp_up;
        custom_Button btn_mp_down;
        custom_ToggleSwitch ts_sp = new custom_ToggleSwitch();
        custom_ToggleSwitch ts_mp = new custom_ToggleSwitch();
        public frm_Start()
        {
            InitializeComponent();

            //add toggle-switch controls
            ts_sp.CheckedChanged += ts_sp_CheckedChanged;
            ts_mp.CheckedChanged += ts_mp_CheckedChanged;
            ts_sp.Checked = !Properties.Settings.Default.mode_classic_sp;
            ts_mp.Checked = !Properties.Settings.Default.mode_classic_mp;

            ts_sp.Location = new Point(panel_sp_outer.Location.X + 40, 350);
            ts_sp.Width = 80;
            ts_sp.Height = 30;
            ts_mp.Location = new Point(panel_mp_outer.Location.X + 40, 350);
            ts_mp.Width = 80;
            ts_mp.Height = 30;
            this.Controls.Add(ts_sp);
            this.Controls.Add(ts_mp);

            //relocate icons
            pb_sp_classic.Location = new Point(ts_sp.Location.X-35, ts_sp.Location.Y);
            pb_sp_modern.Location = new Point(ts_sp.Location.X + ts_sp.Width + 5, ts_sp.Location.Y);

            pb_mp_classic.Location = new Point(ts_mp.Location.X - 35, ts_mp.Location.Y);
            pb_mp_modern.Location = new Point(ts_mp.Location.X + ts_mp.Width + 5, ts_mp.Location.Y);

            //inital values for rows and columns
            cmb_rows.SelectedItem = "20";
            cmb_cols.SelectedItem = "10";

            //placement of custom buttons on the form
            btn_sp_left = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_left), new Point(panel_sp_outer.Location.X, panel_sp_outer.Location.Y + 230),new Size(50,50));
            btn_sp_right = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_right), new Point(panel_sp_outer.Location.X + 110, panel_sp_outer.Location.Y + 230), new Size(50, 50));
            btn_sp_up = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_up), new Point(panel_sp_outer.Location.X + 55, panel_sp_outer.Location.Y + 175), new Size(50, 50));
            btn_sp_down = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_down), new Point(panel_sp_outer.Location.X + 55, panel_sp_outer.Location.Y +230), new Size(50, 50));
            btn_mp_left = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_left), new Point(panel_mp_outer.Location.X, panel_mp_outer.Location.Y + 230), new Size(50, 50));
            btn_mp_right = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_right), new Point(panel_mp_outer.Location.X + 110, panel_mp_outer.Location.Y + 230), new Size(50, 50));
            btn_mp_up = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_up), new Point(panel_mp_outer.Location.X + 55, panel_mp_outer.Location.Y + 175), new Size(50, 50));
            btn_mp_down = new custom_Button(frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_down), new Point(panel_mp_outer.Location.X + 55, panel_mp_outer.Location.Y + 230), new Size(50, 50));
            btn_sp_left.Click += btn_sp_left_Click;
            btn_sp_right.Click += btn_sp_right_Click;
            btn_sp_up.Click += btn_sp_up_Click;
            btn_sp_down.Click += btn_sp_down_Click;
            btn_mp_left.Click += btn_mp_left_Click;
            btn_mp_right.Click += btn_mp_right_Click;
            btn_mp_up.Click += btn_mp_up_Click;
            btn_mp_down.Click += btn_mp_down_Click;
            this.Controls.Add(btn_sp_left);
            this.Controls.Add(btn_sp_right);
            this.Controls.Add(btn_sp_up);
            this.Controls.Add(btn_sp_down);
            this.Controls.Add(btn_mp_left);
            this.Controls.Add(btn_mp_right);
            this.Controls.Add(btn_mp_up);
            this.Controls.Add(btn_mp_down);
            //add tool-tips to controls
            tooltip.SetToolTip(btn_sp_left, "Tastenbelegung für Links");
            tooltip.SetToolTip(btn_sp_right, "Tastenbelegung für Rechts");
            tooltip.SetToolTip(btn_sp_up, "Tastenbelegung für Drehen");
            tooltip.SetToolTip(btn_sp_down, "Tastenbelegung für Fallen lassen oder Links rotieren");
            tooltip.SetToolTip(btn_mp_left, "Tastenbelegung für Links");
            tooltip.SetToolTip(btn_mp_right, "Tastenbelegung für Rechts");
            tooltip.SetToolTip(btn_mp_up, "Tastenbelegung für Drehen");
            tooltip.SetToolTip(btn_mp_down, "Tastenbelegung für Fallen lassen oder Links rotieren");
            tooltip.SetToolTip(pb_sp, "Spiel für 1 Spieler starten!");
            tooltip.SetToolTip(pb_mp, "Spiel für 2 Spieler starten!");
            tooltip.SetToolTip(pb_slow, "Langsam");
            tooltip.SetToolTip(pb_slow, "Schnell");
            tooltip.SetToolTip(pb_sp_classic, "Taste nach unten lässt Block fallen");
            tooltip.SetToolTip(pb_sp_modern, "Taste nach unten rotiert Paket nach links");
            tooltip.SetToolTip(pb_mp_classic, "Taste nach unten lässt Block fallen");
            tooltip.SetToolTip(pb_mp_modern, "Taste nach unten rotiert Paket nach links");

            //color-settings
            panel_sp_outer.BackColor = Color.FromArgb(64, 64, 64);
            panel_mp_outer.BackColor = Color.FromArgb(64, 64, 64);
            lbl_sp.ForeColor = Color.FromArgb(64, 64, 64);
            lbl_mp.ForeColor = Color.FromArgb(64, 64, 64);
            panel_sp_inner.BackColor = Color.White;
            panel_mp_inner.BackColor = Color.White;
            cmb_rows.BackColor = Color.FromArgb(64, 64, 64);
            cmb_cols.BackColor = Color.FromArgb(64, 64, 64);
            cmb_rows.ForeColor = Color.FromArgb(255, 152, 0); ;
            cmb_cols.ForeColor = Color.FromArgb(255, 152, 0);
        }

        //change between classic and modern mode ands save setting
        private void ts_sp_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.mode_classic_sp = !ts_sp.Checked;
            Properties.Settings.Default.Save();
        }

        private void ts_mp_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.mode_classic_mp = !ts_mp.Checked;
            Properties.Settings.Default.Save();
        }


        //open the KeyListener-form to change the current key 
        private void btn_sp_left_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("sp_left", Properties.Settings.Default.key_sp_left);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();          
        }
        private void btn_sp_right_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("sp_right", Properties.Settings.Default.key_sp_right);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();
        }
        private void btn_sp_up_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("sp_up", Properties.Settings.Default.key_sp_up);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();
        }
        private void btn_sp_down_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("sp_down", Properties.Settings.Default.key_sp_down);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();
        }
        private void btn_mp_left_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("mp_left", Properties.Settings.Default.key_mp_left);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();
        }
        private void btn_mp_right_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("mp_right", Properties.Settings.Default.key_mp_right);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();
        }
        private void btn_mp_up_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("mp_up", Properties.Settings.Default.key_mp_up);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();
        }
        private void btn_mp_down_Click(object sender, EventArgs e)
        {
            frm_Key = new frm_KeyListener("mp_down", Properties.Settings.Default.key_mp_down);
            frm_Key.FormClosing += KeyListener_FormClosing;
            frm_Key.Show();
        }
        
        //update key method is called once KeyListener-form is closed
        private void KeyListener_FormClosing(object sender, FormClosingEventArgs e)
        {
            update_Keys();
        }

        //update keys from settings to display correctly
        private void update_Keys()
        {      
            btn_sp_left.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_left);
            btn_sp_right.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_right);
            btn_sp_up.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_up);
            btn_sp_down.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_sp_down);
            btn_mp_left.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_left);
            btn_mp_right.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_right);
            btn_mp_up.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_up);
            btn_mp_down.Text = frm_KeyListener.translate_key(Properties.Settings.Default.key_mp_down);
        }

        /// <summary>
        /// launch game as a singleplayer
        /// </summary>
        private void pb_sp_Click(object sender, EventArgs e)
        {
            frm_Game = new frm_Paketbote(false,Convert.ToInt32(cmb_rows.Text), Convert.ToInt32(cmb_cols.Text), trackbar_speed.Value);
            frm_Game.StartPosition = FormStartPosition.Manual;
            frm_Game.Location = new Point(this.Location.X, 50);
            frm_Game.Show();
            this.Hide();
        }
        /// <summary>
        /// launch game for 2 players
        /// </summary>
        private void pb_mp_Click(object sender, EventArgs e)
        {
            frm_Game = new frm_Paketbote(true, Convert.ToInt32(cmb_rows.Text), Convert.ToInt32(cmb_cols.Text), trackbar_speed.Value);
            frm_Game.StartPosition = FormStartPosition.Manual;
            frm_Game.Location = new Point(this.Location.X, 50);
            frm_Game.Show();
            this.Hide();
        }

        //draw horizontal line for settings
        private void frm_Start_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawLine(new Pen(new SolidBrush(Color.FromArgb(64, 64, 64)), 5), new Point(0, 450), new Point(this.Width, 450));
        }

        //everything below this line is the animation of the hover-effect
        private void pb_sp_MouseEnter(object sender, EventArgs e)
        {
            panel_sp_outer.BackColor = Color.FromArgb(255, 152, 0);
            panel_sp_inner.BackColor = Color.White;
            pb_sp.Image = Properties.Resources.icon_sp_color;
            lbl_sp.ForeColor = Color.FromArgb(255, 152, 0);
        }

        private void pb_sp_MouseLeave(object sender, EventArgs e)
        {
            panel_sp_outer.BackColor = Color.FromArgb(64, 64, 64);
            panel_sp_inner.BackColor = Color.White;
            pb_sp.Image = Properties.Resources.icon_sp_default;
            lbl_sp.ForeColor = Color.FromArgb(64, 64, 64);
        }

        private void pb_mp_MouseEnter(object sender, EventArgs e)
        {
            panel_mp_outer.BackColor = Color.FromArgb(255, 152, 0);
            panel_mp_inner.BackColor = Color.White;
            pb_mp.Image = Properties.Resources.icon_mp_color;
            lbl_mp.ForeColor = Color.FromArgb(255, 152, 0);
        }

        private void pb_mp_MouseLeave(object sender, EventArgs e)
        {
            panel_mp_outer.BackColor = Color.FromArgb(64, 64, 64);
            panel_mp_inner.BackColor = Color.White;
            pb_mp.Image = Properties.Resources.icon_mp_default;
            lbl_mp.ForeColor = Color.FromArgb(64, 64, 64);
        }
    }
}
